@echo off
:: Script per annullare le modifiche precedenti - Vito Lattanzi
:: www.gentiluomodigitale.it

:: Verifica se lo script è eseguito come amministratore
openfiles >nul 2>nul
if %errorlevel% neq 0 (
    echo Non sono privilegi amministrativi, riavvio con diritti di amministratore...
    powershell -Command "Start-Process cmd -ArgumentList '/c %~s0' -Verb RunAs"
    exit
)

:: Percorso della chiave di registro per DeferFeatureUpdates
set "regKey=HKLM\SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate"
set "regValue=DeferFeatureUpdates"

:: Verifica se la chiave di registro DeferFeatureUpdates esiste
reg query "%regKey%" >nul 2>nul
if %errorlevel% neq 0 (
    echo La chiave di registro "%regKey%" non esiste. Nessuna modifica da annullare.
) else (
    :: Elimina il valore "DeferFeatureUpdates"
    reg delete "%regKey%" /v "%regValue%" /f >nul
    echo La chiave di registro "DeferFeatureUpdates" e' stata rimossa.
    
    :: Elimina la chiave di registro "WindowsUpdate" se non contiene altri valori
    reg query "%regKey%" >nul 2>nul
    if %errorlevel% equ 0 (
        reg delete "%regKey%" /f >nul
        echo La chiave di registro "%regKey%" e' stata rimossa.
    )
)

:: Aggiungi la verifica e la rimozione della chiave DriverSigning
set "driverSigningKey=HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\DriverSigning"
set "driverSigningValue=DriverSigning"

:: Verifica se la chiave di registro DriverSigning esiste
reg query "%driverSigningKey%" >nul 2>nul
if %errorlevel% neq 0 (
    echo La chiave di registro "%driverSigningKey%" non esiste. Nessuna modifica da annullare.
) else (
    :: Elimina il valore "DriverSigning"
    reg delete "%driverSigningKey%" /v "%driverSigningValue%" /f >nul
    echo La chiave di registro "DriverSigning" e' stata rimossa.
    
    :: Elimina la chiave di registro "DriverSigning" se non contiene altri valori
    reg query "%driverSigningKey%" >nul 2>nul
    if %errorlevel% equ 0 (
        reg delete "%driverSigningKey%" /f >nul
        echo La chiave di registro "%driverSigningKey%" e' stata rimossa.
    )
)

echo Le modifiche precedenti sono state annullate con successo.
pause